import numpy as np
from abc import ABC, abstractmethod


class SignalProcessor(ABC):
    """
    Abstract class
    """
    @abstractmethod
    def process_signal(self, signal: np.ndarray) -> np.ndarray:

        raise NotImplemented('Derived classes must implement')

    def noise_estimate(self, signal: np.ndarray) -> np.ndarray:
        """
        Provide an estimate of the noise generated on the signal
        """
        return signal * 0.0
