import numpy as np
import pytest
from skcomponents.processing import GaussianNoise, PoissonCounting


def test_gaussian(signal):
    np.random.seed(0)
    noise = GaussianNoise(noise_level=0.01)
    signal = noise.process_signal(signal)
    true_signal = np.array([[1.01764052, 1.00400157],
                            [1.00978738, 1.02240893]])
    assert np.allclose(signal, true_signal)


def test_poisson(signal):

    np.random.seed(0)
    poisson = PoissonCounting()
    signal = poisson.process_signal(signal * 100)
    true_signal = np.array([[101, 103], [98, 98]])
    print(signal)
    assert np.allclose(signal, true_signal)
